<?php
/*
Plugin Name: WS AudioPlayer
Plugin URI: http://www.icyleaf.cn/2007/11/05/wordpress-plugin-ws-audio-player-09-released/
Description: 可在日志插入且附带下载功能的在线Flash播放器。点<a href="admin.php?page=ws-audio-player/options-wsaudioplayer.php">这里</a>查看详细说明以及相关设置。(Add Audio Player with Download function to your blog. After active,you can <a href="admin.php?page=ws-audio-player/options-wsaudioplayer.php">Click here</a> goto setting page.
Version: 1.0.2
Author: icyleaf
Author URI: http://www.icyleaf.cn
*/

// Global variables
$wsap_playerURL = get_settings('siteurl') . '/wp-content/plugins/ws-audio-player/audioplayer.swf';

function wsap_add_options_page() {
	add_options_page('WS AudioPlayer Options', 'WS AudioPlayer', 'manage_options', 'ws-audio-player/options-wsaudioplayer.php');
}
add_action('admin_head', 'wsap_add_options_page');

// Declare instances global variable
$wsap_instances = array();

// Filter function (inserts player instances according to behaviour option)
function wsap_insert_player($content = '') {
	global $wsap_behaviour, $wsap_instances;

	// Reset instance array
	$wsap_instances = array();
	$content = preg_replace_callback( "/\[audio=(([^]]+))]/i", "wsap_player", $content );
	return $content;
}

// Callback function for preg_replace_callback
function wsap_player($matches) {
	global $wsap_playerURL, $wsap_instances, $wsap_playerID;

	// Get next player ID
	$wsap_playerID++;
	// Build FlashVars string (url encode everything)
	$flashVars = "audio" . $wsap_playerID;

	// Split options
	$data = preg_split("/[\|]/", $matches[2]);
	$files = array();

	foreach( explode( ",", $data[0] ) as $afile ) {
		array_push( $files, $afile );
	}
	$file = implode( ",", $files );

	$source = split( ",", $file );


	if(is_feed()) {
		$output = '<br />作者使用 <a href="http://www.icyleaf.cn/tag/ws-audioplayer/">WS Audio Player</a> 插入了一音乐。(Author insert a music with <a href="http://www.icyleaf.cn/tag/ws-audioplayer/">WS Audio Player</a>)';
		if($source[1]!=""){
			$output .= '<br />Download (<a href="' . $source[0] . '" title="Download ' . $source[1] . '"/>' . $source[1] . '</a>).';
		}else{
			$output .= '<br />(<a href="' . $source[0] . '" />Download</a>) this music.';
		}
	}else{
	$output = '<div class="wsaudioplayer">
			<div class="wsflashplayer">';
	$output .= '<embed width="100%" height="26" flashvars="url=' . $source[0] . '" wmode="transparent" quality="high" class="audio" name="' . $flashVars . '" src="' . $wsap_playerURL . '" type="application/x-shockwave-flash"/></embed></div>';

	if($source[2]=="download") $output .= '<a href="' . $source[0] . '" title="Download ' . $source[1] .'" class="wsdownload">Download</a>';
	if($source[1]!="") $output .= '<span class="wsmusicdesc">'. $source[1] . '</span>';
	$output .='</div></p>';
	}
	return $output;
}
// Add filter hook
add_filter('the_content', 'wsap_insert_player');


function wsap_wp_head() {
	global $wsap_playerID;

	$wsap_css = get_option('wsap_css_setting');
	switch( $wsap_css ) {
		case 'wsap_css_white':$wsap_css = "screen_white.css";break;
		case 'wsap_css_blue':$wsap_css = "screen_blue.css";break;
		case 'wsap_css_classic':$wsap_css = "screen_classic.css";break;
		case 'wsap_css_custom':$wsap_css = "screen.css";break;
		default:$wsap_css = "screen_white.css";
	}

	echo "\n\t<!--Begin[CSS for WS Audio Player]-->\n\t";
	echo '<link type="text/css" rel="stylesheet" href="' . get_settings("siteurl") . '/wp-content/plugins/ws-audio-player/css/' . $wsap_css  .'" />';
	echo "\n\t<!--End[CSS for WS Audio Player]-->\n\n";
}
add_action('wp_head', 'wsap_wp_head');


if (strpos($_SERVER['REQUEST_URI'], 'post.php') || strpos($_SERVER['REQUEST_URI'], 'post-new.php') || strpos($_SERVER['REQUEST_URI'], 'page-new.php') || strpos($_SERVER['REQUEST_URI'], 'page.php')) {
add_action('admin_footer', 'wsap_AddQuickTag');

function wsap_AddQuickTag(){
echo '<script type="text/javascript">
		<!--
		var wsapToolbar = document.getElementById("ed_toolbar");
		if(wsapToolbar){
			var wsapNr = edButtons.length;';

echo "edButtons[edButtons.length] = new edButton('ed_wsap','','','','');";
echo 'var wsapBut = wsapToolbar.lastChild;
			while (wsapBut.nodeType != 1){
				wsapBut = wsapBut.previousSibling;
			}

			wsapBut = wsapBut.cloneNode(true);
			wsapToolbar.appendChild(wsapBut);
			//toolbar.appendChild(wsapBut);
			wsapBut.value = \'MP3\';
			wsapBut.onclick = edInsertwsap;
			wsapBut.title = "Input Music with WS Audio Player plugins";
			wsapBut.id = "ed_wsp";
		}

		function edInsertwsap() {
			if(!edCheckOpenTags(wsapNr)){';

			echo "var U = prompt('";
			_e('请输入MP3地址[MP3 URI]','wsap');
			echo "' , 'http://');
					var W = prompt('";
			_e('是否显示歌曲名,不显示请留空[Will you show Music Name?]','wsap');
			echo "' , '');
					var H = prompt('";
			_e('是否可以下载,不可以请留空,默认为可以下载[Can it download?]','wsap');
			echo "' , 'download');
					var theTag = '[audio=' + U + ',' + W + ',' + H + ']';";
			echo	'edButtons[wsapNr].tagStart  = theTag;
				edInsertTag(edCanvas, wsapNr);
			} else {
				edInsertTag(edCanvas, wsapNr);
			}
		}

		//-->
		</script>';
}
}
?>
